//点击国家时，显示城市列表，可以在调用时预先载入一项数据
var SetSelectCountryRegionCustomer = function(base, country_id, city_id, city_container, instance, chain) {
	this.initialize(base, country_id, city_id, city_container, instance, chain);
};

SetSelectCountryRegionCustomer.prototype = {
	initialize : function(base, country_id, city_id, city_container, instance, chain) {
		this.base = base;
		this.country_id = country_id;
		this.city_id = city_id;
		this.city_container = city_container;
		this.instance = (instance) ? instance : 'objSelectCountryRegionCustomer';//获取实例名
		this.chain = chain;
		this.cache = {};
	},
	
	getData : function(obj) {
		this.obj = obj;
		
		if (obj.id == this.country_id) {
			this.father_id = 0;
		} else {
			this.father_id = obj.val();
		}
		
		$("#" + this.country_id).parents('form').find("input[name=rg_aid]").val(this.father_id);
		
		var sibling = obj.nextAll('select');
		sibling.each(function() {
			$(this).remove();
		});
		
		var newImgElement = "<img class='running_img' src=" + this.base + "/skin/df/img/loading.gif />";
		obj.after(newImgElement);
		
		var parameters = 'country=' + escape($("#" + this.country_id).val()) + '&father_id=' + escape(this.father_id);
		var onSuccess = this.setData.bind(this);
		
		if (this.cache[$("#" + this.country_id).val() + " " + this.father_id] != undefined) {
			this.setData(this.cache[$("#" + this.country_id).val() + " " + this.father_id]);
		} else {
			//未选择时
			if (this.father_id === '') {
				this.setData({"responseText" : "[]"});
			} else {
				$.get(this.base + '/countryregion/list/', parameters, onSuccess, "json");
			}
		}
	},

	setData : function(transport) {
		this.cache[$("#" + this.country_id).val() + " " + this.father_id] = transport;
		var data = transport;

		if (data.length > 0) {
			//var attr_style = ' style="margin:0 10px 10px 0;width: auto;padding:0 5px;" ';
			var attr_style = '';
			var attr_onchange = ' onchange="' + this.instance + '.getData($(this))" ';
			var attr_id = ' id="' + this.instance + '-father-' + this.father_id + '" ';
			var select_string = '<select ' + attr_style + attr_onchange + attr_id + '></select>';
			
			this.obj.after(select_string);
			
			var new_select_element = $('#' + this.instance + '-father-' + this.father_id);
			new_select_element.attr('class', 'validate-select');
			
			var newOpElement = $("<option value='' selected='selected'>-请选择-</option>");
			new_select_element.append(newOpElement);
			
			for (var i = 0; i < data.length; i++) {
				var newOpElement = $("<option></option>").text(data[i]['name']);
				newOpElement.id = this.instance + '-region-' + data[i]['aid'];
				newOpElement.attr('value', data[i]['aid'])
				
				if (this.father_id == data[i]['aid']) {
					newOpElement.attr('selected', 'selected');
				}
				new_select_element.append(newOpElement);
			}
		}
		
		if (this.obj.parent().find('.running_img')) this.obj.parent().find('.running_img').remove();
		
		//如果没有获取到城市列表，则显示TEXT框
		var sibling = $("#" + this.country_id).siblings();
		if (!sibling.size()) {
			$("#" + this.country_id).parents('form').find(this.city_container).each(function() {
				$(this).show();
			});
			$("#" + this.city_id).addClass('required-entry');
		} else {
			$("#" + this.country_id).parents('form').find(this.city_container).each(function() {
				$(this).hide();
			});
			$("#" + this.city_id).removeClass('required-entry');
		}

		if (this.chain != undefined && this.chain.length > 0) {
			var popchain = this.chain.shift();
			var lastselect = $("#" + this.instance + '-father-' + this.father_id);
			lastselect.val(popchain);
			eval(this.instance + '.getData(lastselect)');
		}

		if (this.chain != undefined && this.chain.length == 0) {
			//编辑地址时放到页面显示
			//默认地址prototype
			$("#J_AddressEditBox").find("select").each(function() {
				var select_val = $(this).val();
				if (select_val != '' && select_val != 'cn') {
					var arr_val = [];
					$("#J_AddressEditBox").find("select option:selected").each(function() {
						var select_val = $(this).text();
						if (select_val != '-请选择-') {
							arr_val.push(select_val);
						}
					});
					arr_val = arr_val.join('-');
					$("#J_AddressEditValue").text(arr_val);
					$("#J_AddressEditValue").css("color", "#000000");
					$("#J_AddressEditValue").css("text-align", "left");
				}
			});
		}
	},

	failure : function(transport) {
		alert('Error: ' + transport.statusText);
	}
};
